#include "path.h"

/* Achtung, integer Arithmetik vorhanden, groesse nicht unbegrenzt */
/* Wichtig, das Bitfeld wird immer quadratisch ansehen und muss    */
/* durch 8 teilbar sein                                            */
#define KARTENGROESSE	32

class Navigation
{
private:

	char	far *m_KartenZeiger;					// Zeiger auf den Kartenspeicher
	int	m_intWegGefunden;						// Flag fuer WWeg wurde gefunden
	_asNode  m_StartPunkt;						// Koordinaten des Starts
	_asNode  m_EndPunkt;                   // Koordinaten des Endpunkt
	_asNode  m_LastPunkt;						// Letzte Angefahrener Punkt

	CPathFinder	PathSucher;						// Basis  Klasse fuer A-Star 
	char		*BitPointer(int,int);			// Gib Zeiger auf das Byte
	char		BitMaske(int);						// Bitmaske (gesetztes Bit)


public:
  Navigation(); 									// Klasse wird angelegt
  ~Navigation();									// Klasse wird beendet
  void	StartPunkt(int,int);					// Startpunkt einstellen
  void	EndPunkt(int, int);					// Endpunkt einstellen
  void	SetzeHindernis(int,int);			// Setze ein Hindernis in die Karte
  void	LoescheHindernis(int,int);			// Loesche ein Hindernis aus der Karte	
  int		IstHindernis(int,int);				// Ist an dieser Stelle ein Hindernis
  _asNode *WegBeginn(void);					// Gehe zum Beginn des Weges
  _asNode *WegWeiter(void);  					// naechste Koordinate zum Ziel

  void Find();                            // Suche den Weg
  static int FeldFrei(int, int, void far *);	// Ist ein Hindernis auf dem Feld
  static	int Kosten(int, int,  void far *);	// Kosten fuer das Betreten des Feldes
  int WegGefunden( void );	
};
